#include<fstream>
#include<algorithm>

using namespace std;

int systemnum;
string expression;
string letters;
string sum[9];
char res[9];
char tores[9];

bool used[256], notzero[256];

int factorial(int num){
    int product = 1;
    for(int i = 2; i <= num; i++){
        product *= i;
    }
    return product;
}

int main(){
    ifstream in;
    ofstream out;
    in.open("cripto.in");
    out.open("cripto.out");

    in >> systemnum >> expression;
    char addtosum[9];
    int digits = 0;
    int res_start;
    for(int i = 0; i < expression.size(); i++){
        char c = expression[i];
        if(c == '+' || c == '='){
            for(int i = digits-1; i >= 0; i--){
                sum[digits - i - 1].push_back(addtosum[i]);
            }
            if(c == '+'){
                digits = 0;
                continue;
            }
            if(c == '='){
                res_start = i+1;
                break;
            }
        }
        if(digits == 0) notzero[c] = true;
        if(!used[c]) letters.push_back(c);
        used[c] = true;
        addtosum[digits++] = c;
    }
    notzero[expression[res_start]] = true;
    int res_size = 0;
    while(res_start + res_size < expression.size()){
        char c = expression[res_start + res_size];
        tores[res_size] = c;
        if(!used[c]){
            letters.push_back(c);
        }
        res_size++;
    }
    for(int i = 0; i < res_size; i++){
        res[i] = tores[res_size - i - 1];
    }
    int s = letters.size();
    while(letters.size() < systemnum) letters.push_back(1);
    int fact = factorial(systemnum) / factorial(systemnum - s);
    for(int k = 0; k < fact; k++){
        next_permutation(letters.begin(), letters.end());
        if(notzero[letters[0]]) continue;
        int letter_to_num[256];
        for(int i = 0; i < systemnum; i++){
            letter_to_num[letters[i]] = i;
        }
        int num_res[9];
        for(int i = 0; i < 9; i++){
            if(res[i] == 0){
                num_res[i] = 0;
                continue;
            }
            num_res[i] = letter_to_num[res[i]];
        }
        int carry = 0;
        for(int i = 0; i < 9; i++){
            int digit = 0;
            for(int j = 0; j < sum[i].size(); j++){
                digit += letter_to_num[sum[i][j]];
            }
            if((digit + carry)%systemnum != num_res[i]){
                carry = 1;
                break;
            }
            carry = (digit + carry)/systemnum;
        }
        if(carry) continue;
        for(int i = 0; i < expression.size(); i++){
            char c = expression[i];
            if(c == '+' || c == '='){
                out << c;
                continue;
            }
            out << letter_to_num[c];
        }
        out << endl;
    }

    out.close();
    in.close();
}
