/* GCC */
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)


using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
const lint inf = 1000*1000*1000 + 7;

vector<int> graph[230], cp, ccp;
vector<bool> used;
int V, start, fin;

bool check(int u) {
    fill(all(used), 0);
    queue<int> q;
    q.push(start);
    used[start] = true;
    while (!q.empty()) {
        int v = q.front(); q.pop();
        for (int i = 0; i < graph[v].size(); i++) {
            int w = graph[v][i];
            if (w == fin) return false;
            if (!used[w] && w != u) {
                q.push(w);
                used[w] = true;
            }
        }
    }
    return true;
}

bool check_even_more(int u) {
    vector<bool> used2(V+1, false);
    queue<int> q;
    q.push(u);
    used2[u] = true;
    while (!q.empty()) {
        int v = q.front(); q.pop();
        for (int i = 0; i < graph[v].size(); i++) {
            int w = graph[v][i];
            if (!used2[w]) {
                q.push(w);
                used2[w] = true;
            }
        }
    }
    int cnt = 0;
    for (int v = 1; v <= V; v++) {
        if (used[v] && used2[v]) return false;
        cnt += used[v];
    }
    return (cnt > 1 && cnt < V-2);
}


int main() {
    files(race);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    int u, v;
    string s;
    for(u = 1; getline(cin, s) /*&& u <= 10*/; u++) {
        stringstream ss(s);
        while (ss >> v)
            graph[u].push_back(v);
    }

    V = u-1;
    used.assign(V+1, false);

    for (u = 1; u <= V; u++) {
        if (graph[u].empty()) fin = u;
        for (int i = 0; i < graph[u].size(); i++)
            used[graph[u][i]] = true;
    }

    for (u = 1; u <= V; u++)
        if (!used[u]) start = u;

    for (int u = 1; u <= V; u++) {
        if (!check(u)) continue;
        cp.push_back(u);
        if (check_even_more(u))
            ccp.push_back(u);
    }

    cout << start << ' ' << fin << '\n';
    cout << cp.size();
    for (int i = 0; i < cp.size(); i++)
        cout << ' ' << cp[i];
    cout << '\n' << ccp.size();
    for (int i = 0; i < ccp.size(); i++)
        cout << ' ' << ccp[i];
    cout << '\n';

    return 0;
}
