#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <set>
#include <map>
#include "memory.h"

using namespace std;

vector<string> str;
vector<char> A;
vector<int> B;

int n;

void Check() {
	map<char, int> Q;
	for(int i = 0; i < A.size(); i++) Q[A[i]] = B[i];

	long long res = 0;
	for(int i = 0; i < str.size()-1; i++) {
		long long num = 0;
		for(int j = 0; j < str[i].size(); j++) {
			num = num*n + Q[str[i][j]];
		}
		res += num;
	}

	long long num = 0;
	for(int j = 0; j < str.back().size(); j++) {
		num = num*n + Q[str.back()[j]];
	}

	if (res == num) {
		for(int i = 0; i < str.size(); i++) {
			for(int j = 0; j < str[i].size(); j++) printf("%d", Q[str[i][j]]);

			if (i == str.size()-1) printf("\n");
			else if (i == str.size()-2) printf("=");
			else printf("+");
		}
	}
}

int main() {
	freopen("cripto.in", "r", stdin);
	freopen("cripto.out", "w", stdout);

	char ch;
	scanf("%d%c", &n, &ch);
	string s = "";

	while (scanf("%c", &ch) != -1) {
		if (ch == '\n' || ch == '\0') break;
		if (ch == '+' || ch == '=') { str.push_back(s); s = ""; } else s += ch;
	}
	str.push_back(s);


	for(int i = 0; i < str.size(); i++)
		for(int j = 0; j < str[i].size(); j++)
			A.push_back(str[i][j]);

	sort(A.begin(), A.end());
	A.erase(unique(A.begin(), A.end()), A.end());

	for(int i = 0; i < n; i++) B.push_back(i);

	do {
		bool c = true;
		for(int i = A.size()+1; i < B.size(); i++) if (B[i] < B[i-1]) c = false;
		if (c) Check();
	}
	while (next_permutation(B.begin(), B.end()));


	return 0;
}
