/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>

using namespace std;

vector < vector <int> > ank;
string letters = "";

bool in_used (vector<int> used, int& num) {
    /*for (int j = 0; j = used.size(); j++) {
            cout << used[j] << " ";
        }
        cout << endl;*/
    for (int i = 0; i < used.size(); i++) {
        if (num == used[i]) return true;
    }
    return false;
}

void find_ank (int k, int& n, vector<int> start) {
    /*for (int j = 0; j = start.size(); j++) {
        cout << start[j] << " ";
    }
    cout << endl;*/
    if (k <= 0) {
        ank.push_back(start);
        /*for (int j = 0; j = start.size(); j++) {
            cout << start[j] << " ";
        }
        cout << endl;*/
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!in_used(start, i)) {
            start.push_back(i);
            find_ank(k-1, n, start);
            start.pop_back();
        }
    }

}

int main()
{
    FILE* in;
    in = fopen("cripto.in", "r");
    vector <string> adds;
    string res;

    int base;
    fscanf(in, "%d", &base);


    while(true) {
        string curr;
        char c;
        c = getc(in);
        if (isspace(c)) continue;
        if (c == '+' || c == '=') {
            adds.push_back(curr);
            curr = "";
            if (c == '=') {
                while (true) {
                   c = getc(in);
                   if (isspace(c)) {
                        break;
                   }
                   res = res + c;
                    bool known = false;
                    for (int i = 0; i < letters.size(); i++) {
                    if (letters[i] == c) {
                        known = true;
                        break;
                    }
            }
            if (!known) letters = letters + c;
                }
                break;
            }
        } else {
            curr = curr + c;
            bool known = false;
            for (int i = 0; i < letters.size(); i++) {
                if (letters[i] == c) {
                    known = true;
                    break;
                }
            }
            if (!known) letters = letters + c;
        }
    }

    cout << letters << endl;
    vector <int> empt;
    empt.clear();
    int k = letters.size();
    find_ank(k, base, empt);
    for (int i = 0; i < ank.size(); i++) {
        for (int j = 0; j = ank[i].size(); j++) {
            cout << ank[i][j] << " ";
        }
        cout << endl;
    }

    int vars = ank.size();
    for (int i = 0; i < vars; i++) {
        int res_sum = 0;
        bool works = true;
        string var = "";
        string var_res = "";
        for (int j = res.size()-1; j >= 0; j--) {
            int coef = 0;
            for (int x = 0; x < k; x++) {
                if (letters[x] == res[j]) {
                    coef = ank[i][x];
                    break;
                }
            }
            res_sum = res_sum*10 + coef;
            var_res = (coef-'0') + var_res;
        }
        unsigned long long sum = 0;
        for (int add = 0; add < adds.size(); adds++) {
            string cadd = adds[add];
            string var_add = "";
            unsigned long long add_sum = 0;
            for (int j = cadd.size()-1; j >= 0; j--) {
                int coef = 0;
                for (int x = 0; x < k; x++) {
                    if (letters[x] == cadd[j]) {
                        coef = ank[i][x];
                        break;
                    }
                }
                add_sum = add_sum*10 + coef;
                var_add = (coef - '0') + var_add;
            }
            sum += add_sum;
            var = var + "+" + var_add;
        }
    }

    return 0;
}
