/* GCC */
#include <iostream>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;
int base, sum;
vector<vector<char> > arrCh(10);
vector<vector<int> > arr(10, vector<int> (10, -1));
map<char, int> chin;
vector<int> values(10, -1);
vector<bool> used(10, false);
vector<int> remain(10, 0);

void fileOut(){
    for(int i=0; i<=sum; i++){
        for(int z=arrCh[i].size()-1; z>=0; z--){
            printf("%d", values[arr[i][z]]);
        }
        if(i<sum-1) printf("+");
        if(i==sum-1) printf("=");
    }
    printf("\n");
}

void readData(){
    freopen("cripto.in", "r", stdin);

    scanf("%d", &base);
    string s;
    getline(cin, s);
    char c;
    int curr=0;
    while(!feof(stdin)){
        scanf("%c", &c);
        if(c=='='){
            sum=curr+1;
        }
        if(c=='=' || c=='+') {
            reverse(arrCh[curr].begin(), arrCh[curr].end());
            curr++;
            continue;
        }
        arrCh[curr].push_back(c);
    }
    arrCh[sum].erase(arrCh[sum].end()-2, arrCh[sum].end());
    reverse(arrCh[sum].begin(), arrCh[sum].end());

    fclose(stdin);
}

void toNums(){
    int counter=0;
    for(int i=0; i<9; i++){
        for(int z=0; z<=sum; z++){
            if(i>=arrCh[z].size()) continue;
            if(chin.count(arrCh[z][i])>0){
                arr[z][i]=chin[arrCh[z][i]];
            } else {
                chin[arrCh[z][i]]=counter;
                arr[z][i]=counter;
                counter++;
            }
        }
    }
}

void bust(int dig, int num){
    for(int i=num; i<=sum; i++){
        if(arr[i][dig]==-1) continue;
        if(values[arr[i][dig]]==-1){
            for(int z=0; z<base; z++){
                if(used[z]) continue;
                if(dig==arrCh[i].size()-1 && z==0) continue;
                used[z]=true;
                values[arr[i][dig]]=z;
                bust(dig, i);
                used[z]=false;
                values[arr[i][dig]]=-1;
            }
            return;
        }
    }
    //all nums are setted
    int curr=remain[dig];
    for(int i=0; i<sum; i++){
        if(dig==arrCh[i].size()-1 && values[arr[i][dig]]==0) return;
        if(arr[i][dig]==-1) continue;
        curr+=values[ arr[i][dig] ];
    }
    if(arr[sum][dig]==-1 && curr==0){
        fileOut();
        return;
    }
    if(curr%base==values[ arr[sum][dig] ]){
        remain[dig+1]=curr/base;
        bust(dig+1, 0);
        remain[dig+1]=0;
    }
}

int main(){
    freopen("cripto.out", "w", stdout);
    readData();
    toNums();
    bust(0, 0);
    fclose(stdout);
    return 0;
}
