#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int Nmax = 300, mod = 1e9 + 7;

vector<int> g[Nmax];
int start, finish;
bool used[Nmax], used_[Nmax];

void check(int v, int p) {
    used[v] = true;
    for(int i = 0;i < g[v].size();i++) {
        int w = g[v][i];
        if(w == p || used[w])
            continue;
        check(w, p);
    }
}
bool check2(int v) {
    used_[v] = true;

    if(used[v])
        return false;
    for(int i = 0;i < g[v].size();i++) {
        int w = g[v][i];
        if(used[w])
            return false;
        if(used_[w])
            continue;
        if(!check2(w))
            return false;
    }

    return true;
}
int main()
{
    ///777777777777777777777777777777777777777777
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    freopen("race.in", "r", stdin);
    freopen("race.out", "w", stdout);
    ///777777777777777777777777777777777777777777

    int n = 0, hV;
    string hS;
    stringstream s;

    getline(cin, hS);

    while(!cin.eof()) {
        s.clear();
        s.str(hS);
        if(hS == "")
            finish = n;
        while(s >> hV) {
            hV--;
            g[n].push_back(hV);
            used[hV] = true;
        }
        n++;
        getline(cin, hS);
    }

    for(int i = 0;i < n;i++)
    if(!used[i]) {
        start = i;
        break;
    }

    cout << start+1 << ' ' << finish+1 << '\n';

    vector<int> part, need;

    for(int i = 0;i < n;i++) {

        if(i == start || i == finish)
            continue;

        for(int j = 0;j < n;j++) {
            used[j] = false;
            used_[j] = false;
        }

        check(start, i);
        if(!used[finish]) {
            need.push_back(i);
            if(check2(i)) {
                for(int j = 0;j < n;j++) {
                    if(j != start && used[j] && j != i) {
                        for(int k = 0;k < n;k++)
                            if(k != finish && !used[k] && k != i) {
                                part.push_back(i);
                                break;
                            }
                        break;
                    }
                }
            }
        }
    }

    if(need.begin() == need.end()) {
        cout << "0\n0\n";
        return 0;
    }

    cout << need.size() << ' ';

    for(int i = 0;i < need.size()-1;i++) {
        cout << need[i]+1<< ' ';
    }

    cout << need[need.size()-1]+1 << '\n';

    if(part.begin() == part.end()) {
        cout << "0\n";
        return 0;
    }

    cout << part.size() << ' ';

    for(int i = 0;i < part.size()-1;i++) {
        cout << part[i]+1 << ' ';
    }

    cout << part[part.size()-1]+1 << '\n';
    return 0;
}
