/* GCC */
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)


using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
const lint inf = 1000*1000*1000 + 7;

typedef vector<wchar_t> w_string;
typedef map<int, int>::iterator mit;

vector<w_string> terms;
vector<int> digits;
map<int, int> coeffs;
set<map<int, int> > anses;
set<int> nozero;
map<int, int> ans;

bool check() {
    ans.clear();
    int sum = 0;
    int i = 0;
    for (mit it = coeffs.begin(); it != coeffs.end(); ++it, ++i) {
        if (nozero.count(it->first) && digits[i] == 0) return false;
        sum += (it->second)*digits[i];
        ans[it->first] = digits[i];
    }
    if (sum == 0 && !anses.count(ans)) {
        anses.insert(ans);
        return true;
    }
    return false;
}
int base;


vector<char> signs;

int main() {
    files(cripto);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    cin >> base;
    string s;
    cin >> s;
    int n = s.size();
    terms.push_back(w_string(0));
    int flag = 1;

    for (int i = 0; i < n; i++) {
        if (s[i] != '+' && s[i] != '=') {
            terms.back().push_back(s[i]);
        }
        else {
            signs.push_back(s[i]);
            int ten = 1;
            for (int j = terms.back().size()-1; j >= 0 ; j--)
                coeffs[(int)terms.back()[j]] += ten*flag, ten *= base;
            if (terms.back().size() > 1) nozero.insert(terms.back()[0]);
            terms.push_back(w_string(0));
            if (s[i] == '=') flag = -1;
        }
    }

    if (terms.back().size() > 1) nozero.insert(terms.back()[0]);
    int ten = 1;
    for (int j = terms.back().size()-1; j >= 0; j--)
        coeffs[(int)terms.back()[j]] += ten*flag, ten *= base;

    //for (mit it = coeffs.begin(); it != coeffs.end(); ++it)
        //cout << (char)it->first << ' ' << it->second << '\n';

    n = terms.size();

    if (coeffs.size() > base)
        return 0;

    digits.resize(base);
    for (int i = 0; i < base; i++)
        digits[i] = i;

    do {
        if (check()) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < terms[i].size(); j++)
                    cout << ans[terms[i][j]];
                if (i != n-1) cout << signs[i];
            }
            cout << '\n';
        }
    } while (next_permutation(all(digits)));



//    for (int i = 0; i < n; i++)
//        for (int j= 0; j < terms[i].size(); j++)
//            cout << (int)terms[i][j] << '\n';

    return 0;
}
