/* GCC */
#include <bits/stdc++.h>

using namespace std;
vector <vector <int> > adj;
vector <int> ans1,ans2;
bool used[250];
int start, finish, cnt;

void bfs(int v, int p){
    memset(used, 0, sizeof(used));
    used[p] = 1;
    queue<int> q;
    q.push(v);
    cnt = 0;
    while (!q.empty()){
        int cur  = q.front();
        q.pop();
        for (int i = 0; i < adj[cur].size(); ++i)
            if (!used[adj[cur][i]]){
                used[adj[cur][i]] = 1;
                ++cnt;
                q.push(adj[cur][i]);
            }
    }
}

int main()
{
    freopen("race.in", "r", stdin);
    freopen("race.out", "w", stdout);
    int n = 0;
    adj.resize(250);
    string s;
    while (getline(cin,s)){
        if (s == "-1") break;
        ++n;
        stringstream ss(s);
        int temp;
        while(ss >> temp){
            used[temp] = 1;
            adj[n].push_back(temp);
        }
        if (!adj[n].size()) finish = n;
    }
    for (int i = 1; i <= n; ++i)
        if (!used[i]){
            start = i;
            break;
        }
    for (int i = 1; i <= n; ++i){
        if (i == finish || i == start) continue;
        bfs(start, i);
        if (!used[finish]) ans1.push_back(i);
    }
    for (int i = 0; i < ans1.size(); ++i){
        bfs(ans1[i],0);
        if (!used[ans1[i]] && cnt > 1 && cnt < n - 2) ans2.push_back(ans1[i]);
    }
    printf("%d %d\n", start, finish);
    if (!ans1.size()){
        printf("%d\n%d\n", 0, 0);
        return 0;
    }
    printf("%d ", ans1.size());
    for (int i = 0; i < ans1.size() - 1; ++i)
        printf("%d ", ans1[i]);
    printf("%d\n", ans1[ans1.size()-1]);
    if (!ans2.size()){
        printf("%d\n", 0);
        return 0;
    }
    printf("%d ", ans2.size());
    for (int i = 0; i < ans2.size() - 1; ++i)
        printf("%d ", ans2[i]);
    printf("%d\n", ans2[ans2.size()-1]);
    return 0;
}
