#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>
#include <sstream>
using namespace std;

vector <int> DD;
vector <bool> DB;
int start, finish, pos, n;

bool bfs(vector <vector <int> > X, int nod){
    if ((nod == start) || (nod == finish)) return false;

    DD.assign(1,start);
    DB.assign(n, true);
    for (int i=0; i<DD.size(); i++){
        pos = DD[i];
        if ((pos != nod)&&(DB[pos])){
            DB[pos] = false;
            for (int j=0; j<X[pos].size(); j++){
                DD.push_back(X[pos][j]);
            }
        }
    }
    return DB[finish];
}

bool bfsD(vector <vector <int> > X, vector <vector <int> > Y, vector <vector <int> > Z, int nod){
    if ((nod == start) || (nod == finish)) return false;

    DD.assign(1,start);
    DB.assign(n, true);
    for (int i=0; i<DD.size(); i++){
        pos = DD[i];
        if ((pos != nod)&&(DB[pos])){
            DB[pos] = false;
            for (int j=0; j<X[pos].size(); j++){
                DD.push_back(X[pos][j]);
            }
        }
    }
    if (Y[start].size()==1 && Y[start][0]==nod) return false;
    if (Z[finish].size()==1 && Z[finish][0]==nod) return false;
    for (int i=0; i<Y[nod].size(); i++) if (!DB[Y[nod][i]]) return false;
    for (int i=0; i<Z[nod].size(); i++) if (DB[Z[nod][i]]) return false;
    return (DB[finish]);
}

int main(){
    //freopen("1in.txt", "r", stdin);
    freopen("race.in", "r", stdin);
    freopen("race.out", "w", stdout);
    int k;
    vector <vector <int> > A,AA,AAA;
    char ch[750];
    while (gets(ch) != 0){
        A.push_back(vector <int> ());
        n++;
        stringstream ss;
        ss << ch;
        while (ss >> k) A.back().push_back(k-1);
    }

    vector <int> B,C,D;
    B.assign(n+1,0);
    for (int i=0; i<n; i++){
        if (A[i].size()==0) finish = i;
        else {
            for (int j=0; j<A[i].size(); j++) B[ A[i][j] ] = 1;
        }
    }
    while (B[start] == 1) start++;

    AA.resize(n+1);
    AAA.resize(n+1);

    for (int i=0; i<n; i++){
        for (int j=0; j<A[i].size(); j++){
            AA[i].push_back(A[i][j]);
            AA[A[i][j]].push_back(i);
            AAA[A[i][j]].push_back(i);
        }
    }

    for (int i=0; i<n; i++){
        if (bfs(A, i)) {
            C.push_back(i);
            if (bfsD(AA, A, AAA, i)) D.push_back(i);
        }
    }

    printf("%d %d\n", start+1, finish+1);
    printf("%d",C.size());
    for (int i=0; i<C.size(); i++) printf(" %d", C[i]+1); printf("\n");
    printf("%d",D.size());
    for (int i=0; i<D.size(); i++) printf(" %d", D[i]+1); printf("\n");

    fclose(stdin);
    fclose(stdout);
    return 0;
}


/*
    for (int i=0; i<n+1; i++){
        for (int j=0; j<A[i].size(); j++){
            printf("%d ", A[i][j]);
        }
        printf("\n");
    }
*/
